* FINDER.PRG
*
* Xbase++ "FINDER" program.
*
* PROGRAMMER:
*   (1) To compile: xpp finder.prg
*   (2) To link: alink finder.obj wsc32.lib mio32.lib
*

#INCLUDE "DLL.CH"
#INCLUDE "WSC32.CH"
#INCLUDE "MIO32.CH"

Procedure Main()
LOCAL Code
LOCAL nPort
LOCAL FirstPort
LOCAL LastPort

FirstPort = COM1
LastPort = COM4

? "FINDER 8/1/2000"
?
?  "  Searching COM" + LTRIM(STR(1+FirstPort)) + " to COM" + LTRIM(STR(1+LastPort))
?? " for connected modem."
?

* search each port in turn
for nPort = FirstPort TO LastPort
  * set parmameters for the port
  Code = xSioParms(nPort,WSC_NoParity,WSC_OneStopBit,WSC_WordLength8)
  * reset port
  Code = xSioReset(nPort, 512, 512)
  ? "Resetting COM" + LTRIM(STR(1+nPort))
  if Code >= 0
     * found UART
     Code = xSioBaud(nPort, 19200)
     Code = xSioDTR(nPort, ASC("S"))
     Code = xSioRTS(nPort, ASC("S"))
     * modem should set DSR
     Code = xSioPutc(nPort,13)
     Sleep(250)
     if xSioDSR(nPort) = 0
       * DSR not set
       ? "  DSR is not set."
       Code = xSioDone(nPort)
     else
       * modem has set DSR
       ? "  DSR is set, sending 'AT', expecting 'OK' back."
       * send "AT" + CR
       Code = XmioSendTo(nPort, 200, "AT!")
       do while XmioDriver(nPort) <> MIO_IDLE
       enddo
       * expect "OK" back
       Code = XmioWaitFor(nPort, 2500, "OK")
       do while XmioDriver(nPort) <> MIO_IDLE
       enddo
       Code = XmioResult(nPort)
       if Code = 0
         ? "  Error: OK not seen."
         Code = xSioDone(nPort)
         return
       endif
       if Code > 0
         ? "  Success: OK seen! Modem found on this port."
         Code = xSioDone(nPort)
         return
       endif
     endif
  endif
endfor
return

Procedure SayError(ErrCode)
   LOCAL Code
   LOCAL Buffer
   if ErrCode < 0
     ? "ERROR " + STR(ErrCode)
     Buffer = SPACE(128)
     Code = xSioWinError(@Buffer, 128)
     if Code > 0
       ? Left(Buffer,Code)
     endif
   endif
return

