*
* SIMPLE.PRG
*
* Xbase++ "SIMPLE" program.
*
* PROGRAMMER:
*   (1) To compile: xpp simple.prg
*   (2) To link: alink simple.obj wsc32.lib
*

#INCLUDE "DLL.CH"
#INCLUDE "WSC32.CH"

Procedure Main(cArg1, cArg2)
LOCAL Code
LOCAL Port
LOCAL Baud
LOCAL Buffer
LOCAL C

? "SIMPLE 8/1/2000"

* get port number from command line
if cArg1 == nil
  ? "Usage: SIMPLE port baudrate"
  ? "   Eg: SIMPLE 1 19200"
  return
else
  Port = Val(cArg1) - 1
endif
* get baud rate from command line
if cArg2 == nil
  ? "Usage: SIMPLE port baudrate"
  return
else
  Baud = Val(cArg2)
endif

?
? "Using COM" + LTRIM(STR(1+Port)) + " @ " + LTRIM(STR(Baud))
?

Code = xSioReset(Port, 1024, 1024)

if Code < 0
  ? "ERROR " + Str(Code)
  Buffer = SPACE(128)
  Code = xSioWinError(@Buffer, 128)
  if Code > 0
    ? Left(Buffer,Code)
  endif
endif

xSioBaud(Port, Baud)
xSioDTR(Port, ASC("S"))
xSioRTS(Port, ASC("S"))

* uncomment the following line if using a modem
***xSioFlow(Port, ASC("H"))

? "Begin terminal loop (type ^Z to exit)"
?

do while .T.
  * any keyboard input ?
  C = InKey()
  if C = 26
    * user has typed ^Z
    exit
  endif
  if C > 0
    * send keyboad character
    xSioPutc(Port, C)
  endif
  * any serial input ?
  C = xSioGetc(Port)
  if C <> WSC_NO_DATA
    * display character just received
    ?? Chr(C)
  endif
enddo

xSioDone(Port)
? "All Done"
return



