*
* YMS.PRG [YMODEM Send]
*
* Xbase++ "YMS" program.
*
* PROGRAMMER:
*   (1) To compile: xpp yms.prg
*   (2) To link: alink yms.obj wsc32.lib xydrv32.lib
*

#INCLUDE "DLL.CH"
#INCLUDE "WSC32.CH"
#INCLUDE "XYDRV32.CH"

#define ONE_K     1
#define YMODEM    1

Procedure Main(cArg1, cArg2, cArg3)
LOCAL  Code
LOCAL  xPort
LOCAL  Baud
LOCAL  FileName

? "_______________"
?
? "YMS 8/1/2000 (Xbase++)"

* get command line arguments
if cArg1 == nil
  Usage()
  return
else
  * Get COM port
  xPort = Val(cArg1) - 1
endif

* get baud rate from command line
if cArg2 == nil
  Usage()
  return
else
  Baud = Val(cArg2)
endif

* get filename from command line
if cArg3 == nil
  Usage()
  return
else
  Filename = cArg3
endif

? "Port : COM" + LTRIM(STR(1+xPort))
? "Baud : " + STR(Baud)
? "File : " + Filename
? "_______________"

*** PROGRAMMER: delete next line in registered version ***
? "*** Type 'SW Info' on tool bar at bottom of screen ! ***"
*** END-PROGRAMMER ***

* reset port (8N1 is default)
Code = xSioReset(xPort,1040,1040)
if Code < 0
  SayError(Code)
  return
endif

* set baud rate
Code = xSioBaud(xPort,Baud)
if Code < 0
  SayError(Code)
  return
endif

* set DTR & RTS
Code = xSioDTR(xPort,ASC("S"))
Code = xSioRTS(xPort,ASC("S"))

* set parms
Code = xSioParms(xPort, WSC_NoParity, WSC_OneStopBit, WSC_WordLength8)
* set hardware flow control
Code = xSioFlow(xPort, ASC("H"))
* acquire xyDriver
Code = XxyAcquire(xPort, xPort)
* set xyDriver debug level
Code = XxyDebug(0)
? "Starting YMODEM send (type Control-BREAK to quit)"
Code = XxyStartTX(xPort, Filename, ONE_K, YMODEM)

* run the YMODEM driver
RunXY(xPort)
? "DONE"

Code = XxyRelease()
Code = xSioDone(xPort)
return

Procedure RunXY(xPort)
  LOCAL  Code
  LOCAL  Buffer
  LOCAL  Packet
  LOCAL  LastPacket
  LastPacket = -1
  do while .T.
    * run the driver
    Code = XxyDriver(xPort)
    * any messages from xyDriver ?
    Buffer = SPACE(80)
    do while XxyGetMessage(xPort, @Buffer, 80) > 0
      ? Buffer
    enddo
    if Code = XY_IDLE
      return
    else
      * xyDriver is running
      Packet = XxyGetParameter(xPort, XY_GET_PACKET)
      if Packet <> LastPacket
         * show packet number
         ?? " P" + LTRIM(STR(Packet))
         if mod(Packet,10) = 9
           ?
         endif
         LastPacket = Packet
       endif
    endif
  enddo
return

Procedure Usage()
  ? " Usage: YMS <port> <baud> <filename>"
  ? " Example: YMS 1 19200 myfile.dat"
  return

Procedure SayError(ErrCode)
   LOCAL Code
   LOCAL Buffer
   if ErrCode < 0
     ? "ERROR " + STR(ErrCode)
     Buffer = SPACE(128)
     Code = xSioWinError(@Buffer, 128)
     if Code > 0
       ? Left(Buffer,Code)
     endif
   endif
return



